image: "python:3.5"

before_script:
  # Check and print Python version
  - python --version
  # Create SSH configuration directory if necessary (also parents with -p, mode: read/write/exec):
  - mkdir -p --mode=700 ~/.ssh/
  # Add SSH key for jutil:
  - echo "$ID_RSA_JUTIL_PRIVATE" > ~/.ssh/id_rsa_jutil
  # Provide read access to owner (octal value code: 400) to jutil key and known_hosts with chmod:
  - chmod 400 ~/.ssh/id_rsa_jutil
  # Configure SSH to use ~/.ssh/jutil_key for iffgit.fz-juelich.de (-e allows \n):
  - echo -e "Host iffgit.fz-juelich.de\n\tIdentityFile ~/.ssh/id_rsa_jutil\n" > ~/.ssh/config
  # Add iffgit.fz-juelich.de to known_hosts (not the same key as Jutil!):
  - echo iffgit.fz-juelich.de,134.94.161.83 "$ID_RSA_IFFGIT_PUBLIC" > ~/.ssh/known_hosts
  # Provide read access to owner (octal value code: 400) to known_hosts with chmod:
  - chmod 400 ~/.ssh/known_hosts
  # Install jutil via secure ssh connection:
  - pip install git+ssh://gitlab@iffgit.fz-juelich.de/unger/jutil.git

stages:
  - test

test:
  stage: test
  script:
    # TODO: Different jobs with custom develop arguments? extra_requires (hyperspy, plotting)?
    # TODO: Use pip install -e .[hyperspy], etc.
    # Install requirements (-e: editable, like python setup.py develop, but pip, not easy_install):
    - pip install -e .  # TODO: belongs here or before_script?
    - python setup.py test
